/*
 * Copyright (c) 2019 Tilman Sauerbeck (tilman at code-monkey de)
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

pub enum Ringbuf {
}

extern {
    fn ringbuf_is_empty(ringbuf: *const Ringbuf) -> bool;
    fn ringbuf_is_full(ringbuf: *const Ringbuf) -> bool;
    fn ringbuf_write(ringbuf: *mut Ringbuf, value: u8);
    fn ringbuf_read(ringbuf: *const Ringbuf) -> u8;
}

impl Ringbuf {
    pub fn is_empty(&self) -> bool {
        unsafe { ringbuf_is_empty(self) }
    }

    pub fn is_full(&self) -> bool {
        unsafe { ringbuf_is_full(self) }
    }

    pub fn write(&mut self, value: u8) {
        unsafe { ringbuf_write(self, value) }
    }

    pub fn read(&self) -> u8 {
        unsafe { ringbuf_read(self) }
    }
}
